<?php if (!defined('BASEPATH')) exit('No direct script access allowed'); 

/**
 * плагин для MaxSite CMS
 * (c) http://max-3000.com/
 */
//Функция, пересчитывающая массив меток и картинок им соответствующих. Вызывается из админки плагина нажатием на кнопку
//Формирует поименованый массив значений вида метка->массив картинок ей соответствующих

function taggallery_recalc_subdir($dir='' , $url='' , $gallery_array = array()) //рекурентная для taggallery_recalc()
{
	$all_dirs = directory_map($dir, true); 
	$out = '';
	foreach ($all_dirs as $d)
	{
	  $subdir = $dir.$d.'/';
	  $suburl = $url.$d.'/';
		if (is_dir($subdir)) 		// это каталог?
		{
		  if ($d != '_mso_float' and $d != 'mini' and $d != '_mso_i' and $d != 'smiles')
	    {
         $gallery_array = taggallery_recalc_subdir($subdir , $suburl, $gallery_array);
			}	
			if ($d  == '_mso_i')
			{
			  //берем описания файлов этого каталога
				$fn_mso_descriptions = $dir . '_mso_i/_mso_descriptions.dat';
 	      if (file_exists( $fn_mso_descriptions )) 
	      {
		      // массив данных: fn => описание )
		      $mso_descritions = unserialize( read_file($fn_mso_descriptions) ); // получим из файла все описания
		      //строим из этих описаний массив 'tag' => $tag ,'file' => $key , 'dir' => $dir
		      foreach ($mso_descritions as $key => $value)
		      {
		        if ($value != '')
		        {  
			        $fn_mso_file = $dir . $key;
 	            if (file_exists( $fn_mso_file ))
 	            { 
		             $tags = mso_explode($value, false, false);
		             foreach ($tags as $tag) 
		             {
		                $element = array ('tag' => $tag ,'file' => $key , 'dir' => $url , 'desc' => $value );
		                $gallery_array[] = $element;
		             } 
		           }   
		        }  
		      }
	      }
			}
			
		}  
	}
	return $gallery_array;
}


//Функция, пересчитывающая массив меток и картинок им соответствующих. Вызывается из админки плагина нажатием на кнопку
//проходит по всем вложенным директориям, находит описания файлов
//разбивает описания по запятым на метки и добавляет в массив элемент "метка","имя файла","директорий файла"
function taggallery_recalc()
{
 // global $MSO;
  $out = array();
  $CI = & get_instance();
	$CI->load->helper('file'); // хелпер для работы с файлами
	$CI->load->helper('directory');
	$CI->load->helper('form');
	//$dir = $MSO->config['uploads_dir'];
	$dir = getinfo('uploads_dir');
	$url = getinfo('uploads_url');
	$out = taggallery_recalc_subdir($dir, $url);
  return $out;
}

//Формирует поименованый массив значений вида метка->массив описаний ей соответствующих
//описание является массивом из двух элементов "имя файла","директорий файла"
//за основание берет массив полученный в результате работы function taggallery_recalc()
function taggallery_recalc2($gallery_array = array())
{
  $out = array();
  foreach ($gallery_array as $file)
  {
      if (isset($out[$file['tag']]))
        {
          $out[$file['tag']][] = array('dir' => $file['dir'] , 'file' => $file['file'], 'desc' => $file['desc']);
        }
        else
        {
          $out[$file['tag']]= array();
          $out[$file['tag']][] = array('dir' => $file['dir'] , 'file' => $file['file'] , 'desc' => $file['desc']);
        }
  }
  return $out;
}
 
# функция автоподключения плагина
function taggallery_autoload($args = array())
{
    mso_create_allow('taggallery_edit', t('Админ-доступ к taggallery', __FILE__));
    mso_hook_add('custom_page_404', 'taggallery_custom_page_404');
    mso_hook_add('admin_init', 'taggallery_admin_init'); # хук на админку

}

function taggallery_custom_page_404($args=false)
{
 $options = mso_get_option('taggallery', 'plugins', array());
 if ( !isset($options['gallery_slug']) ) $options['gallery_slug'] = 'pictures'; 
 if ( !isset($options['gallery_content_end']) ) $options['gallery_content_end'] = 'checked="true"'; 
 if ( !isset($options['gallery_name']) ) $options['gallery_name'] = 'Галерея';
 if ( !isset($options['gallery_array']) ) $options['gallery_array'] = array();
 $gallery_slug = $options['gallery_slug'];
 $segment = mso_segment(1);
 if ($segment == $gallery_slug)
 {
   require(getinfo('plugins_dir').'taggallery/gallery.php');
   return true;
 }
 return $args;
}

# функция выполняется при активации (вкл) плагина
function taggallery_activate($args = array())
{    
    return $args;
}
  
# функция выполняется при деактивации (выкл) плагина
function taggallery_deactivate($args = array())
{  
   return $args;
}
  
# функция выполняется при деинсталляции плагина
function taggallery_uninstall($args = array())
{
    mso_delete_option('taggallery', 'plugins'); // удалим созданные опции
    return $args; 
}

function taggallery_custom($response = '')
{    
     return $args;
}
  
  # при входе в админку
function taggallery_admin_init($args = array()) 
 {
     if ( !mso_check_allow('taggallery_edit') ) return $args;
  
     $this_plugin_url = 'taggallery'; // url и hook 
     
     # добавляем свой пункт в меню админки
     # первый параметр - группа в меню
     # второй - это действие/адрес в url - http://сайт/admin/demo
     # Третий - название ссылки    
     mso_admin_menu_add('plugins', $this_plugin_url, 'taggallery');
  
     # прописываем для указаного url
     # связанную функцию именно она будет вызываться, когда 
     # будет идти обращение по адресу http://сайт/admin/demo
     mso_admin_url_hook ($this_plugin_url, 'taggallery_admin_page');
     
     return $args;
 }
  
 # функция вызываемая при хуке, указанном в mso_admin_url_hook
 function taggallery_admin_page($args = array()) 
 {
  //   global $MSO;
     if ( !mso_check_allow('taggallery_edit') ) 
     {
         echo 'Доступ запрещен';
         return $args;
     }
     
     mso_hook_add_dinamic( 'mso_admin_header', ' return $args . "taggallery"; ' );
     mso_hook_add_dinamic( 'admin_title', ' return "taggallery - " . $args; ' );
  
     # выносим админские функции отдельно в файл    
    // require($MSO->config['plugins_dir'] . 'taggallery/admin.php');
    require(getinfo('plugins_dir') . 'taggallery/admin.php');
 }
 
 
 
  
  
?>